﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage;
using Microsoft.EntityFrameworkCore.Storage.Internal;
using SIENN.DbAccess;
using System;

namespace SIENN.DbAccess.Migrations
{
    [DbContext(typeof(ApplicationContext))]
    partial class ApplicationContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.0.1-rtm-125");

            modelBuilder.Entity("SIENN.DbAccess.Model.Category", b =>
                {
                    b.Property<string>("Code");

                    b.Property<string>("Description");

                    b.HasKey("Code");

                    b.ToTable("Categories");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.Product", b =>
                {
                    b.Property<string>("Code")
                        .HasMaxLength(10);

                    b.Property<DateTime>("DeliveryDateUtc");

                    b.Property<string>("Description")
                        .HasMaxLength(500);

                    b.Property<bool>("IsAvailable");

                    b.Property<decimal>("Price");

                    b.Property<string>("TypeCode");

                    b.Property<string>("UnitCode");

                    b.HasKey("Code");

                    b.HasIndex("TypeCode");

                    b.HasIndex("UnitCode");

                    b.ToTable("Products");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.ProductCategory", b =>
                {
                    b.Property<string>("ProductCode");

                    b.Property<string>("CategoryCode");

                    b.HasKey("ProductCode", "CategoryCode");

                    b.HasIndex("CategoryCode");

                    b.ToTable("ProductCategory");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.Type", b =>
                {
                    b.Property<string>("Code");

                    b.Property<string>("Description");

                    b.HasKey("Code");

                    b.ToTable("Types");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.Unit", b =>
                {
                    b.Property<string>("Code");

                    b.Property<string>("Description");

                    b.HasKey("Code");

                    b.ToTable("Units");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.Product", b =>
                {
                    b.HasOne("SIENN.DbAccess.Model.Type", "Type")
                        .WithMany("Products")
                        .HasForeignKey("TypeCode");

                    b.HasOne("SIENN.DbAccess.Model.Unit", "Unit")
                        .WithMany("Products")
                        .HasForeignKey("UnitCode");
                });

            modelBuilder.Entity("SIENN.DbAccess.Model.ProductCategory", b =>
                {
                    b.HasOne("SIENN.DbAccess.Model.Category", "Category")
                        .WithMany("ProductCategories")
                        .HasForeignKey("CategoryCode")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("SIENN.DbAccess.Model.Product", "Product")
                        .WithMany("ProductCategories")
                        .HasForeignKey("ProductCode")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
